local _, T = ...

function T.Setup_Bar()
    local player_race = ({UnitRace("player")})[2]
    local player_class = ({UnitClass("player")})[2]
    local player_faction = ({UnitFactionGroup("player")})[1]
    local player_level = UnitLevel("player")
    print(player_race, player_class, player_faction, player_level)

    local racial_active_abilitiy =
        ({
        -- 联盟
        Human = "生存意志(种族特长)",
        Dwarf = "石像形态(种族特长)",
        NightElf = "影遁(种族特长)",
        Gnome = "逃命专家(种族特长)",
        Draenei = "纳鲁的赐福(种族特长)",
        Worgen = "疾步夜行(种族特长)",
        VoidElf = "空间裂隙(种族特长)",
        LightforgedDraenei = "圣光裁决者(种族特长)",
        DarkIronDwarf = "烈焰之血(种族特长)",
        KulTiran = "强力一击(种族特长)",
        Mechagnome = "超有机光影发生器(种族特长)",
        -- 部落
        Orc = "血性狂怒(种族特长)",
        Scourge = "被遗忘者的意志(种族特长)",
        Tauren = "战争践踏(种族特长)",
        Troll = "狂暴(种族特长)",
        BloodElf = "奥术洪流(种族特长)",
        Goblin = "火箭跳(种族特长)",
        Nightborne = "奥术脉冲(种族特长)",
        HighmountainTauren = "蛮牛冲撞(种族特长)",
        MagharOrc = "先祖召唤(种族特长)",
        ZandalariTroll = "再生！(种族特长)",
        Vulpera = "袋里乾坤(种族特长)",
        -- 中立
        Pandaren = "震山掌(种族特长)"
    })[player_race] or "复活战斗宠物"

    local dash_or_mount = player_level < 10 and {"summonmount", "召唤司机"} or {"macro", "跑"}

    -- https://wow.gamepedia.com/Action_slot
    local class_bars = {
        DRUID = {
            -- 平衡
            {
                [1] = {"spell", "猎豹形态"},
                [2] = {"macro", "日月"},
                [3] = {"macro", "星怒"},
                [4] = {"macro", "星涌"},
                [5] = dash_or_mount,
                [6] = {"macro", "自疗"},
                [7] = nil,
                [8] = nil,
                [9] = nil,
                [10] = nil,
                [11] = nil,
                [12] = nil,
                -- 猫形态
                [73] = {"macro", "潜行"},
                [74] = {"macro", "日月"},
                [75] = {"macro", "星怒"},
                [76] = {"macro", "星涌"},
                [77] = dash_or_mount,
                [78] = {"macro", "自疗"},
                [79] = nil,
                [80] = nil,
                [81] = nil,
                [82] = nil,
                [83] = nil,
                [84] = nil,
                -- 熊形态
                [97] = {"spell", "猎豹形态"},
                [98] = {"macro", "日月"},
                [99] = {"macro", "星怒"},
                [100] = {"macro", "星涌"},
                [101] = dash_or_mount,
                [102] = {"macro", "自疗"},
                [103] = nil,
                [104] = nil,
                [105] = nil,
                [106] = nil,
                [107] = nil,
                [108] = nil,
                -- 枭兽形态
                [109] = {"spell", "猎豹形态"},
                [110] = {"macro", "日月"},
                [111] = {"macro", "星怒"},
                [112] = {"macro", "星涌"},
                [113] = dash_or_mount,
                [114] = {"macro", "自疗"},
                [115] = {"spell", "日光术"},
                [116] = {"spell", "清除腐蚀"},
                [117] = {"spell", "安抚"},
                [118] = nil,
                [119] = nil,
                [120] = nil,
                -- 左下动作条
                [61] = {"spell", "愈合"},
                [62] = {"spell", "野性冲锋"},
                [63] = {"spell", "蛮力猛击"},
                [64] = nil,
                [65] = {"spell", "树皮术"},
                [66] = {"spell", "超凡之盟"},
                [67] = nil,
                [68] = nil,
                [69] = nil,
                [70] = nil,
                [71] = {"spell", "急奔"},
                [72] = {"spell", racial_active_abilitiy}
            },
            -- 野性
            {
                [1] = {"spell", "猎豹形态"},
                [2] = {"spell", "熊形态(变形)"},
                [3] = {"spell", "熊形态(变形)"},
                [4] = {"spell", "熊形态(变形)"},
                [5] = dash_or_mount,
                [6] = {"macro", "自疗"},
                [7] = {"macro", "月火"},
                [8] = nil,
                [9] = nil,
                [10] = nil,
                [11] = nil,
                [12] = {"spell", "旋风"},
                -- 猫形态
                [73] = {"macro", "野行"},
                [74] = {"macro", "野性"},
                [75] = {"macro", "撕咬"},
                [76] = {"spell", "迎头痛击"},
                [77] = dash_or_mount,
                [78] = {"macro", "自疗"},
                [79] = {"macro", "月火"},
                [80] = {"spell", "清除腐蚀"},
                [81] = {"spell", "安抚"},
                [82] = nil,
                [83] = nil,
                [84] = {"spell", "旋风"},
                -- 熊形态
                [97] = {"spell", "猎豹形态"},
                [98] = {"spell", "横扫"},
                [99] = {"spell", "裂伤"},
                [100] = {"spell", "迎头痛击"},
                [101] = dash_or_mount,
                [102] = {"macro", "自疗"},
                [103] = {"macro", "月火"},
                [104] = nil,
                [105] = nil,
                [106] = nil,
                [107] = nil,
                [108] = {"spell", "旋风"},
                -- 枭兽形态
                [109] = {"spell", "猎豹形态"},
                [110] = {"macro", "月火"},
                [111] = {"macro", "星怒"},
                [112] = {"macro", "星涌"},
                [113] = dash_or_mount,
                [114] = {"macro", "自疗"},
                [115] = nil,
                [116] = nil,
                [117] = nil,
                [118] = nil,
                [119] = nil,
                [120] = nil,
                -- 左下动作条
                [61] = {"spell", "愈合"},
                [62] = {"spell", "野性冲锋"},
                [63] = {"spell", "蛮力猛击"},
                [64] = nil,
                [65] = {"spell", "树皮术"},
                [66] = {"spell", "生存本能"},
                [67] = {"spell", "狂暴"},
                [68] = nil,
                [69] = nil,
                [70] = {"spell", "狂奔怒吼"},
                [71] = {"spell", "急奔"},
                [72] = {"spell", racial_active_abilitiy}
            },
            -- 守护
            {
                [1] = {"spell", "猎豹形态"},
                [2] = {"spell", "熊形态(变形)"},
                [3] = {"spell", "熊形态(变形)"},
                [4] = {"spell", "熊形态(变形)"},
                [5] = dash_or_mount,
                [6] = {"macro", "自疗"},
                [7] = nil,
                [8] = nil,
                [9] = nil,
                [10] = nil,
                [11] = nil,
                [12] = {"spell", "旋风"},
                -- 猫形态
                [73] = {"macro", "潜行"},
                [74] = {"spell", "熊形态(变形)"},
                [75] = {"spell", "熊形态(变形)"},
                [76] = {"spell", "熊形态(变形)"},
                [77] = dash_or_mount,
                [78] = {"macro", "自疗"},
                [79] = nil,
                [80] = nil,
                [81] = nil,
                [82] = nil,
                [83] = nil,
                [84] = {"spell", "旋风"},
                -- 熊形态
                [97] = {"macro", "守行"},
                [98] = {"macro", "守护"},
                [99] = {"macro", "月火"},
                [100] = {"spell", "迎头痛击"},
                [101] = dash_or_mount,
                [102] = {"macro", "自疗"},
                [103] = {"spell", "清除腐蚀"},
                [104] = {"spell", "夺魂咆哮"},
                [105] = {"spell", "安抚"},
                [106] = nil,
                [107] = nil,
                [108] = {"spell", "旋风"},
                -- 左下动作条
                [61] = {"spell", "狂暴回复"},
                [62] = {"spell", "野性冲锋"},
                [63] = {"spell", "蛮力猛击"},
                [64] = nil,
                [65] = {"spell", "生存本能"},
                [66] = {"spell", "狂暴"},
                [67] = nil,
                [68] = {"spell", "野性成长"},
                [69] = nil,
                [70] = {"spell", "狂奔怒吼"},
                [71] = {"spell", "急奔"},
                [72] = {"spell", racial_active_abilitiy}
            },
            -- 恢复
            {}
        },
        HUNTER = {
            -- 野兽控制
            {
                [1] = {"spell", "复活宠物"},
                [2] = {"macro", "兽王"},
                [3] = {"macro", "倒刺"},
                [4] = {"spell", "反制射击"},
                [5] = dash_or_mount,
                [6] = {"macro", "逃脱"},
                [7] = nil,
                [8] = nil,
                [9] = nil,
                [10] = nil,
                [11] = {"flyout", "宠物管理"},
                [12] = {"flyout", "召唤宠物"},
                -- 左下动作条
                [61] = {"spell", "狂野怒火"},
                [62] = {"spell", "夺命射击"},
                [63] = {"spell", "胁迫"},
                [64] = nil,
                [65] = {"macro", "灵魂"},
                [66] = {"spell", "意气风发"},
                [67] = {"spell", "灵龟守护"},
                [68] = nil,
                [69] = {"spell", "装死"},
                [70] = {"spell", "假死"},
                [71] = {"spell", "猎豹守护"},
                [72] = {"spell", racial_active_abilitiy}
            },
            -- 射击
            {
                [1] = {"spell", "复活宠物"},
                [2] = {"macro", "射击"},
                [3] = {"macro", "稳固"},
                [4] = {"spell", "反制射击"},
                [5] = dash_or_mount,
                [6] = {"macro", "逃脱"},
                [7] = nil,
                [8] = nil,
                [9] = nil,
                [10] = nil,
                [11] = {"flyout", "宠物管理"},
                [12] = {"flyout", "召唤宠物"},
                -- 左下动作条
                [61] = {"macro", "射爆"},
                [62] = {"macro", "震荡"},
                [63] = nil,
                [64] = nil,
                [65] = {"spell", "意气风发"},
                [66] = {"spell", "灵龟守护"},
                [67] = nil,
                [68] = nil,
                [69] = {"spell", "装死"},
                [70] = {"spell", "假死"},
                [71] = {"spell", "猎豹守护"},
                [72] = {"spell", racial_active_abilitiy}
            },
            -- 生存
            {
                [1] = {"spell", "复活宠物"},
                [2] = {"macro", "生2"},
                [3] = {"macro", "生3"},
                [4] = {"spell", "压制"},
                [5] = dash_or_mount,
                [6] = {"macro", "逃脱"},
                [7] = nil,
                [8] = nil,
                [9] = nil,
                [10] = nil,
                [11] = {"flyout", "宠物管理"},
                [12] = {"flyout", "召唤宠物"},
                -- 左下动作条
                [61] = {"macro", "野火"},
                [62] = nil,
                [63] = nil,
                [64] = nil,
                [65] = {"spell", "意气风发"},
                [66] = {"spell", "灵龟守护"},
                [67] = nil,
                [68] = nil,
                [69] = {"spell", "装死"},
                [70] = {"spell", "假死"},
                [71] = {"spell", "猎豹守护"},
                [72] = {"spell", racial_active_abilitiy}
            }
        },
        MAGE = {
            -- 奥术
            {
                [1] = {"macro", "魔爆"},
                [2] = {"macro", "奥术"},
                [3] = {"macro", "弹幕"},
                [4] = {"spell", "法术反制"},
                [5] = dash_or_mount,
                [6] = {"spell", "冰霜新星"},
                [7] = nil,
                [8] = nil,
                [9] = nil,
                [10] = {"spell", "造餐术"},
                [11] = {"spell", "唤醒"},
                [12] = {"macro", "智慧"},
                -- 左下动作条
                [61] = {"macro", "盾"},
                [62] = {"spell", "大法师之触"},
                [63] = {"spell", "变形术"},
                [64] = nil,
                [65] = {"spell", "寒冰屏障"},
                [66] = {"spell", "镜像"},
                [67] = {"spell", "奥术强化"},
                [68] = {"spell", "时间扭曲"},
                [69] = nil,
                [70] = nil,
                [71] = {"spell", "强化隐形术"},
                [72] = {"spell", racial_active_abilitiy}
            },
            -- 火焰
            {},
            -- 冰霜
            {
                [2] = {"macro", "冰枪"},
                [5] = dash_or_mount
            }
        },
        ROGUE = {
            -- 刺杀
            {
                [1] = {"macro", "刺行"},
                [2] = {"macro", "刺杀"},
                [3] = {"spell", "毒伤"},
                [4] = {"macro", "脚踢"},
                [5] = dash_or_mount,
                [6] = {"spell", "疾跑"},
                [7] = nil,
                [8] = nil,
                [9] = nil,
                [10] = nil,
                [11] = nil,
                [12] = nil,
                -- 潜行动作条
                [73] = {"spell", "闷棍"},
                [74] = {"macro", "刺杀"},
                [75] = {"spell", "搜索"},
                [76] = {"spell", "致盲"},
                [77] = dash_or_mount,
                [78] = {"spell", "疾跑"},
                [79] = nil,
                [80] = nil,
                [81] = nil,
                [82] = nil,
                [83] = nil,
                [84] = nil,
                -- 左下动作条
                [61] = {"spell", "猩红之瓶"},
                [62] = {"spell", "暗影步"},
                [63] = {"spell", "肾击"},
                [64] = nil,
                [65] = {"spell", "佯攻"},
                [66] = {"spell", "宿敌"},
                [67] = nil,
                [68] = nil,
                [69] = {"spell", "夺命药膏"},
                [70] = {"spell", "减速药膏"},
                [71] = {"macro", "消失"},
                [72] = {"spell", racial_active_abilitiy}
            },
            -- 狂徒
            {},
            -- 敏锐
            {}
        },
        DEATHKNIGHT = {
            -- 血
            {
                [1] = {"macro", "凋零"},
                [2] = {"macro", "血"},
                [3] = {"macro", "灵打"},
                [4] = {"spell", "心灵冰冻"},
                [5] = dash_or_mount,
                [6] = {"macro", "加速"},
                [7] = nil,
                [8] = nil,
                [9] = nil,
                [10] = nil,
                [11] = {"spell", "控制亡灵"},
                [12] = {"spell", "冰霜之路"},
                -- 左下动作条
                [61] = {"macro", "白骨"},
                [62] = {"spell", "死亡之握"},
                [63] = {"spell", "窒息"},
                [64] = nil,
                [65] = {"spell", "吸血鬼之血"},
                [66] = {"spell", "巫妖之躯"},
                [67] = {"spell", "冰封之韧"},
                [68] = {"spell", "反魔法护罩"},
                [69] = {"macro", "领域"},
                [70] = {"macro", "血握"},
                [71] = nil,
                [72] = {"spell", racial_active_abilitiy}
            },
            -- 冰
            {
                [1] = {"spell", "冷酷严冬"},
                [2] = {"macro", "冰"},
                [3] = {"macro", "灵打"},
                [4] = {"spell", "心灵冰冻"},
                [5] = dash_or_mount,
                [6] = {"macro", "加速"},
                [7] = nil,
                [8] = nil,
                [9] = nil,
                [10] = nil,
                [11] = {"spell", "控制亡灵"},
                [12] = {"spell", "冰霜之路"},
                -- 左下动作条
                [61] = {"spell", "冰霜巨龙之怒"},
                [62] = {"spell", "死亡之握"},
                [63] = {"spell", "窒息"},
                [64] = nil,
                [65] = {"spell", "吸血鬼之血"},
                [66] = {"spell", "反魔法护罩"},
                [67] = {"spell", "符文刃舞"},
                [68] = {"spell", "冰封之韧"},
                [69] = nil,
                [70] = nil,
                [71] = {"macro", "血握"},
                [72] = {"spell", racial_active_abilitiy}
            },
            -- 邪
            {
                [1] = {"macro", "大便"},
                [2] = {"macro", "邪"},
                [3] = {"macro", "灵打"},
                [4] = {"spell", "心灵冰冻"},
                [5] = dash_or_mount,
                [6] = {"macro", "加速"},
                [7] = nil,
                [8] = {"macro", "凋零"},
                [9] = nil,
                [10] = nil,
                [11] = {"spell", "控制亡灵"},
                [12] = {"spell", "冰霜之路"},
                -- 左下动作条
                [61] = {"macro", "邪爆"},
                [62] = {"spell", "死亡之握"},
                [63] = {"spell", "窒息"},
                [64] = nil,
                [65] = {"spell", "反魔法护罩"},
                [66] = {"spell", "冰封之韧"},
                [67] = {"spell", "召唤石像鬼"},
                [68] = {"spell", "亡者大军"},
                [69] = nil,
                [70] = nil,
                [71] = nil,
                [72] = {"spell", racial_active_abilitiy}
            }
        },
        DEMONHUNTER = {
            -- 浩劫
            {
                [1] = {"spell", "献祭光环"},
                [2] = {"macro", "刃舞"},
                [3] = {"macro", "混打"},
                [4] = {"spell", "瓦解"},
                [5] = dash_or_mount,
                [6] = {"spell", "邪能冲撞"},
                [7] = nil,
                [8] = nil,
                [9] = nil,
                [10] = nil,
                [11] = nil,
                [12] = nil,
                -- 左下动作条
                [61] = {"macro", "眼棱"},
                [62] = {"macro", "利刃"},
                [63] = {"spell", "混乱新星"},
                [64] = {"macro", "滑翔"},
                [65] = {"spell", "疾影"},
                [66] = {"spell", "黑暗"},
                [67] = {"macro", "变形"},
                [68] = nil,
                [69] = nil,
                [70] = nil,
                [71] = {"spell", "幽灵视觉"},
                [72] = {"spell", racial_active_abilitiy}
            },
            -- 复仇
            {
                [1] = {"spell", "献祭光环"},
                [2] = {"macro", "咬"},
                [3] = {"macro", "混打"},
                [4] = {"spell", "瓦解"},
                [5] = dash_or_mount,
                [6] = {"spell", "地狱火撞击"},
                [7] = nil,
                [8] = nil,
                [9] = {"macro", "烈焰"},
                [10] = {"spell", "沉默咒符"},
                [11] = {"spell", "悲苦咒符"},
                [12] = {"spell", "锁链咒符"},
                -- 左下动作条
                [61] = {"spell", "邪能毁灭"},
                [62] = {"macro", "利刃"},
                [63] = {"spell", "禁锢"},
                [64] = {"macro", "滑翔"},
                [65] = {"spell", "烈火烙印"},
                [66] = {"macro", "变形"},
                [67] = nil,
                [68] = nil,
                [69] = nil,
                [70] = nil,
                [71] = {"spell", "幽灵视觉"},
                [72] = {"spell", racial_active_abilitiy}
            }
        },
        PALADIN = {
            -- 神圣
            {},
            -- 防护
            {
                [1] = {"macro", "飞盾"},
                [2] = {"macro", "防护"},
                [3] = {"macro", "光"},
                [4] = {"spell", "责难"},
                [5] = dash_or_mount,
                [6] = {"spell", "自由祝福"},
                [7] = {"spell", "神圣马驹"},
                [8] = {"spell", "清毒术"},
                [9] = {"spell", "牺牲祝福"},
                [10] = {"spell", "召唤执事者"},
                [11] = nil,
                [12] = nil,
                -- 左下动作条
                [61] = {"spell", "圣光闪现"},
                [62] = {"spell", "愤怒之锤"},
                [63] = {"spell", "制裁之锤"},
                [64] = nil,
                [65] = {"spell", "炽热防御者"},
                [66] = {"spell", "远古列王守卫"},
                [67] = {"spell", "圣盾术"},
                [68] = {"spell", "保护祝福"},
                [69] = {"spell", "圣疗术"},
                [70] = {"spell", "静谧之瓶"},
                [71] = {"spell", "圣洁鸣钟"},
                [72] = {"spell", racial_active_abilitiy}
            },
            -- 惩戒
            {
                [1] = {"spell", "灰烬觉醒"},
                [2] = {"macro", "惩戒"},
                [3] = {"spell", "神圣风暴"},
                [4] = {"spell", "责难"},
                [5] = dash_or_mount,
                [6] = {"spell", "自由祝福"},
                [7] = {"spell", "神圣马驹"},
                [8] = {"spell", "清毒术"},
                [9] = {"spell", "牺牲祝福"},
                [10] = nil,
                [11] = nil,
                [12] = nil,
                -- 左下动作条
                [61] = {"spell", "圣光闪现"},
                [62] = {"spell", "愤怒之锤"},
                [63] = {"spell", "制裁之锤"},
                [64] = nil,
                [65] = {"spell", "复仇之盾"},
                [66] = {"spell", "复仇之怒"},
                [67] = {"spell", "圣盾术"},
                [68] = {"spell", "保护祝福"},
                [69] = {"spell", "圣疗术"},
                [70] = {"spell", "强效王者祝福"},
                [71] = {"spell", "强效智慧祝福"},
                [72] = {"spell", racial_active_abilitiy}
            }
        },
        SHAMAN = {
            -- 元素
            {
                [1] = {"macro", "地震"},
                [2] = {"macro", "电链"},
                [3] = {"macro", "闪电"},
                [4] = {"spell", "风剪"},
                [5] = dash_or_mount,
                [6] = {"macro", "净化"},
                [7] = {"macro", "狼"},
                [8] = {"spell", "水上行走"},
                [9] = {"spell", "英勇"},
                [10] = {"spell", "嗜血"},
                [11] = nil,
                [12] = nil,
                -- 左下动作条
                [61] = {"spell", "治疗之涌"},
                [62] = {"spell", "治疗之泉图腾"},
                [63] = {"macro", "电能"},
                [65] = {"spell", "星界转移"},
                [66] = {"spell", "土元素"},
                [67] = {"spell", "火元素"},
                [72] = {"spell", racial_active_abilitiy}
            },
            -- 增强
            {},
            -- 恢复
            {
                [1] = {"macro", "熔岩"},
                [2] = {"macro", "电链"},
                [3] = {"macro", "火震"},
                [4] = {"spell", "风剪"},
                [5] = dash_or_mount,
                [6] = {"macro", "净化"},
                [7] = {"macro", "狼"},
                [8] = nil,
                [9] = nil,
                [10] = {"spell", "大地之盾"},
                [11] = {"spell", "水之护盾"},
                [12] = {"spell", "水上行走"},
                -- 左下动作条
                [61] = {"macro", "恢复"},
                [62] = {"spell", "治疗之泉图腾"},
                [63] = {"spell", "电能图腾"},
                [64] = nil,
                [65] = {"spell", "星界转移"},
                [66] = {"spell", "土元素"},
                [67] = {"macro", "灵魂"},
                [68] = {"spell", "治疗之潮图腾"},
                [69] = {"spell", "升腾"},
                [70] = {"spell", "灵魂行者的恩赐"},
                [71] = {"spell", player_faction == "Alliance" and "英勇" or "嗜血"},
                [72] = {"spell", racial_active_abilitiy}
            }
        },
        PRIEST = {
            -- 戒律
            {
                [1] = {"macro", "新星"},
                [2] = {"macro", "痛"},
                [3] = {"macro", "苦修"},
                [4] = nil,
                [5] = dash_or_mount,
                [6] = nil,
                [7] = nil,
                [8] = nil,
                [9] = nil,
                [10] = nil,
                [11] = nil,
                [12] = {"macro", "韧"},
                -- 左下动作条
                [61] = {"spell", "真言术：盾"},
                [62] = nil,
                [63] = nil,
                [64] = {"macro", "漂浮"},
                [65] = nil,
                [66] = nil,
                [67] = nil,
                [68] = nil,
                [69] = nil,
                [70] = nil,
                [71] = nil,
                [72] = {"spell", racial_active_abilitiy}
            },
            -- 神圣
            {
                [1] = {"macro", "震爆"},
                [2] = {"macro", "痛"},
                [3] = {"macro", "惩击"},
                [4] = {"macro", "罚"},
                [5] = dash_or_mount,
                [6] = {"macro", "净化"},
                [7] = {"macro", "羽"},
                [8] = {"macro", "群驱"},
                [9] = nil,
                [10] = {"spell", "绝望祷言"},
                [11] = {"spell", "希望象征"},
                [12] = {"macro", "韧"},
                -- 左下动作条
                [61] = {"macro", "神圣"},
                [62] = {"spell", "圣言术：静"},
                [63] = {"spell", "守护之魂"},
                [64] = {"macro", "漂浮"},
                [65] = {"spell", "治疗之环"},
                [66] = {"spell", "光晕"},
                [67] = {"macro", "灵"},
                [68] = {"spell", "神圣赞美诗"},
                [69] = {"spell", "圣言术：赎"},
                [70] = nil,
                [71] = {"spell", "渐隐术"},
                [72] = {"spell", racial_active_abilitiy}
            },
            -- 暗影
            {}
        },
        WARRIOR = {
            -- 武器
            {},
            -- 狂怒
            {
                [1] = {"spell", "剑刃风暴"},
                [2] = {"spell", "旋风斩"},
                [5] = dash_or_mount,
                [7] = {"spell", "英勇飞跃"},
                [62] = {"spell", "冲锋"}
            },
            -- 防护
            {
                [1] = {"macro", "雷霆"},
                [2] = {"macro", "盾猛"},
                [3] = {"macro", "复仇"},
                [4] = {"macro", "拳击"},
                [5] = dash_or_mount,
                [6] = {"macro", "冲锋"},
                [7] = {"spell", "英勇飞跃"},
                [8] = {"spell", "狂暴之怒"},
                [9] = {"spell", "碎裂投掷"},
                [10] = nil,
                [11] = nil,
                [12] = {"spell", "战斗怒吼"},
                -- 左下动作条
                [61] = {"macro", "乘胜"},
                [62] = {"macro", "斩杀"},
                [63] = {"spell", "震荡波"},
                [64] = {"macro", "投掷"},
                [65] = {"spell", "挫志怒吼"},
                [66] = {"spell", "破釜沉舟"},
                [67] = {"spell", "盾墙"},
                [68] = {"spell", "集结呐喊"},
                [69] = {"spell", "破胆怒吼"},
                [70] = {"spell", "征服者战旗"},
                [71] = {"spell", "血肉铸造"},
                [72] = {"spell", racial_active_abilitiy}
            }
        },
        WARLOCK = {
            -- 痛苦
            {
                [1] = {"macro", "暗箭"},
                [2] = {"macro", "痛苦"},
                [3] = {"macro", "腐种"},
                [4] = nil,
                [5] = dash_or_mount,
                [6] = {"spell", "生命通道"},
                [7] = nil,
                [8] = nil,
                [9] = {"spell", "灵魂石"},
                [10] = {"spell", "制造灵魂之井"},
                [11] = {"spell", "邪能统御"},
                [12] = {"flyout", "召唤恶魔"},
                -- 左下动作条
                [61] = {"macro", "吸血"},
                [62] = {"spell", "恐惧"},
                [63] = {"spell", "暗影之怒"},
                [64] = nil,
                [65] = {"spell", "不灭决心"},
                [66] = {"spell", "召唤黑眼"},
                [67] = nil,
                [68] = nil,
                [69] = nil,
                [70] = nil,
                [71] = nil,
                [72] = {"spell", racial_active_abilitiy}
            },
            -- 恶魔
            {},
            -- 毁灭
            {}
        },
        MONK = {
            -- 酒仙
            {
                [1] = {"macro", "火焰"},
                [2] = {"macro", "酒仙"},
                [3] = {"spell", "分筋错骨"},
                [4] = {"macro", "切喉"},
                [5] = dash_or_mount,
                [6] = {"spell", "活血术"},
                [7] = {"spell", "真气突"},
                [8] = {"spell", "清创生血"},
                [9] = {"spell", "魂体双分：转移"},
                [10] = {"spell", "魂体双分"},
                [11] = nil,
                [12] = {"spell", "金创药"},
                -- 左下动作条
                [61] = {"macro", "天神"},
                [62] = {"spell", "玄牛雕像"},
                [63] = {"spell", "扫堂腿"},
                [64] = {"macro", "碎玉"},
                [65] = {"spell", "壮胆酒"},
                [66] = {"spell", "玄牛下凡"},
                [67] = {"spell", "禅悟冥想"},
                [68] = {"spell", "轮回之触"},
                [69] = nil,
                [70] = nil,
                [71] = {"macro", "禅意"},
                [72] = {"spell", racial_active_abilitiy}
            },
            -- 织雾
            {
                [1] = {"macro", "神鹤"},
                [2] = {"macro", "织雾"},
                [3] = {"macro", "旭日"},
                [5] = dash_or_mount,
                [7] = {"spell", "真气突"}
            },
            -- 踏风
            {}
        }
    }

    local function clear_slot(slot)
        ClearCursor()
        PickupAction(slot)
        return slot + 1
    end

    local function place_macro(name, slot)
        ClearCursor()
        if GetMacroInfo(name) then
            PickupMacro(name) -- PickupMacro名字id皆可
            PlaceAction(slot)
            return slot + 1
        else
            print('找不到宏"' .. name .. '"')
            return slot
        end
    end

    local function place_spell(name, slot)
        ClearCursor()
        local n, _, _, _, _, _, id = GetSpellInfo(name)
        if n then
            PickupSpell(id) -- PickupSpell只接受id，经测试，也作用于坐骑
            PlaceAction(slot)
            return slot + 1
        else
            print('找不到法术"' .. name .. '"')
            return slot
        end
    end

    local function place_item(name, slot)
        ClearCursor()
        local id = GetItemInfoInstant(name)
        if id then
            PickupItem(id) -- 经测试PickupItem也只接受id
            PlaceAction(slot)
            return slot + 1
        else
            print('找不到物品"' .. name .. '"')
            return slot
        end
    end

    local function place_pet(name, slot)
        ClearCursor()
        local _, id = C_PetJournal.FindPetIDByName(name)
        if id then
            C_PetJournal.PickupPet(id)
            PlaceAction(slot)
            return slot + 1
        else
            print('找不到宠物"' .. name .. '"')
            return slot
        end
    end

    local function place_flyout(name, slot)
        -- Flyout弹出式法术按钮只能通过PickupSpellBookItem从法术书中拾取，https://us.battle.net/forums/en/wow/topic/3229376525
        ClearCursor()
        local index_found = nil
        for tab = 1, GetNumSpellTabs() do
            local tab_name, tab_texture, tab_offset, num_entries = GetSpellTabInfo(tab)
            for index = tab_offset + 1, tab_offset + num_entries do
                local skill_type, special = GetSpellBookItemInfo(index, BOOKTYPE_SPELL)
                if skill_type and skill_type == "FLYOUT" then
                    local spell_name, spell_subname = GetSpellBookItemName(index, BOOKTYPE_SPELL)
                    if spell_name == name then
                        index_found = index
                        break
                    end
                end
            end
            if index_found then
                break
            end
        end
        if index_found then
            PickupSpellBookItem(index_found, BOOKTYPE_SPELL)
            PlaceAction(slot)
            return slot + 1
        else
            print('找不到弹出式按钮"' .. name .. '"')
            return slot
        end
    end

    local btn_preset = CreateFrame("Button", nil, SpellBookFrame, "UIPanelButtonTemplate")
    btn_preset:SetText("预设")
    btn_preset:SetSize(btn_preset:GetTextWidth() + 12, btn_preset:GetTextHeight() + 8)
    btn_preset:SetPoint("TOPRIGHT", SpellBookFrame, "TOPRIGHT", -30, 0)

    local btn_clear_all = CreateFrame("Button", nil, SpellBookFrame, "UIPanelButtonTemplate")
    btn_clear_all:SetText("清空")
    btn_clear_all:SetSize(btn_preset:GetTextWidth() + 12, btn_preset:GetTextHeight() + 8)
    btn_clear_all:SetPoint("TOPRIGHT", btn_preset, "TOPLEFT", 0, 0)

    local btn_check = CreateFrame("Button", nil, SpellBookFrame, "UIPanelButtonTemplate")
    btn_check:SetText("检查")
    btn_check:SetSize(btn_preset:GetTextWidth() + 12, btn_preset:GetTextHeight() + 8)
    btn_check:SetPoint("TOPRIGHT", btn_clear_all, "TOPLEFT", 0, 0)

    btn_preset:SetScript(
        "OnClick",
        function(self, button, down)
            -- 显示主动作条、左下动作条和右侧两动作条
            local bl, br, r1, r2 = GetActionBarToggles()
            SetActionBarToggles(1, br, 1, 1)
            SHOW_MULTI_ACTIONBAR_1 = 1
            SHOW_MULTI_ACTIONBAR_3 = 1
            SHOW_MULTI_ACTIONBAR_4 = 1
            MultiActionBar_Update()

            -- 主动作条，左下动作条
            local spec = GetSpecialization() -- 新创建没有设置专精的返回5
            if class_bars[player_class] and class_bars[player_class][spec] then
                for slot, action in pairs(class_bars[player_class][spec]) do
                    if not action then
                        -- 什么都不做
                    elseif not action[1] then
                        clear_slot(slot)
                    elseif action[1] == "macro" then
                        place_macro(action[2], slot)
                    elseif action[1] == "spell" then
                        place_spell(action[2], slot)
                    elseif action[1] == "item" then
                        place_item(action[2], slot)
                    elseif action[1] == "summonmount" then
                        place_spell(action[2], slot)
                    elseif action[1] == "summonpet" then
                        place_pet(action[2], slot)
                    elseif action[1] == "flyout" then
                        place_flyout(action[2], slot)
                    end
                end
            end

            -- 右侧两动作条
            CollectionsJournal_LoadUI() -- 玩具箱是插件形式存在的
            local slot = 25
            -- 常用坐骑
            slot = place_spell("雄壮远足牦牛", slot)
            -- 传送类
            slot = place_spell("星界传送", slot) -- shaman
            slot = place_item("城镇传送之书", slot)
            -- slot = place_item("飞行管理员的哨子", slot)
            slot = place_spell("传送：月光林地", slot) -- dru
            slot = place_spell("梦境行者", slot)
            slot = place_flyout("传送", slot) -- mage
            slot = place_flyout("传送门", slot)
            slot = place_spell("黑锋之门", slot) -- dk
            slot = place_spell("禅宗朝圣", slot) -- monk
            slot = place_item("达拉然炉石", slot)
            slot = place_item("要塞炉石", slot)
            slot = place_item("海军上将的罗盘", slot)
            slot = place_spell("钻探机(种族特长)", slot) -- 黑铁矮人
            slot = place_item("烈酒的遥控器", slot)
            -- 专业技能和公会功能
            -- for _, index in ipairs({GetProfessions()}) do
            --     local name = GetProfessionInfo(index)
            --     print(name)
            --     local spell_to_slot =
            --         ({
            --         ["裁缝"] = "裁缝",
            --         ["附魔"] = "附魔",
            --         ["采矿"] = "采矿技能",
            --         ["工程学"] = "工程学",
            --         ["锻造"] = "锻造",
            --         ["珠宝加工"] = "珠宝加工",
            --         ["草药学"] = "草药学技能",
            --         ["炼金术"] = "炼金术",
            --         ["铭文"] = "铭文",
            --         ["剥皮"] = "剥皮技能",
            --         ["制皮"] = "制皮"
            --     })[name]
            --     if spell_to_slot then
            --         print(spell_to_slot)
            --         slot = place_spell(spell_to_slot, slot)
            --     end
            -- end
            slot = place_spell("符文熔铸", slot) -- 类似于附魔
            slot = place_spell("呼叫大胖(种族特长)", slot) -- 地精的银行
            slot = place_spell("移动银行", slot)
            -- 复活和战复
            local respawn_spells =
                ({
                DRUID = {"起死回生", "复生", "新生"},
                DEATHKNIGHT = {"复活盟友"},
                PALADIN = {"救赎"},
                SHAMAN = {"先祖之魂", "先祖视界"}, -- 萨满有个被动也叫“复生”会提示不能放置
                PRIEST = {"复活术", "群体复活"},
                MONK = {"轮回转世"}
            })[player_class]
            if respawn_spells then
                for _, spell in ipairs(respawn_spells) do
                    print(spell)
                    slot = place_spell(spell, slot)
                end
            end
            -- slot = place_spell("复活战斗宠物", slot)

            -- 最后清理一下光标
            ClearCursor()
        end
    )

    btn_clear_all:SetScript(
        "OnClick",
        function(self, button, down)
            for slot = 1, 120 do
                clear_slot(slot)
            end
        end
    )

    btn_check:SetScript(
        "OnClick",
        function(self, button, down)
            print(player_race)
            print(player_class)

            for slot = 1, 120 do
                if HasAction(slot) then
                    local type, id, stype = GetActionInfo(slot)
                    local name = ""
                    if type == "spell" then
                        name = GetSpellInfo(id)
                    elseif type == "item" then
                        name = GetItemInfo(id)
                    elseif type == "macro" then
                        name = GetMacroInfo(id)
                    elseif type == "companion" then
                        _, name = GetCompanionInfo(stype, id)
                    elseif type == "equipmentset" then
                        name = id
                        id = C_EquipmentSet.GetEquipmentSetID(name)
                    elseif type == "summonmount" then
                        name = C_MountJournal.GetMountInfoByID(id)
                    elseif type == "summonpet" then
                        _, _, _, _, _, _, _, name = C_PetJournal.GetPetInfoByPetID(id)
                    end
                    print(slot, type, id, stype, name)
                end
            end

            for tab = 1, GetNumSpellTabs() do
                local tab_name, tab_texture, tab_offset, num_entries = GetSpellTabInfo(tab)
                for index = tab_offset + 1, tab_offset + num_entries do
                    local skill_type, special = GetSpellBookItemInfo(index, BOOKTYPE_SPELL)
                    if skill_type and skill_type == "FLYOUT" then
                        local spell_name, spell_subname = GetSpellBookItemName(index, BOOKTYPE_SPELL)
                        print(index, tab_name, skill_type, spell_name)
                    end
                end
            end
        end
    )
end
